"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.FormGroupInternal = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formGroup = require("@blueprintjs/core/lib/cjs/components/forms/formGroup.js");

var _intent = require("@blueprintjs/core/lib/cjs/common/intent.js");

var _useFieldApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _blueprintContext = _interopRequireDefault(require("../blueprint-context/blueprint-context"));

var FormGroupInternal = function FormGroupInternal(_ref) {
  var meta = _ref.meta,
      validateOnMount = _ref.validateOnMount,
      helperText = _ref.helperText,
      description = _ref.description,
      hideLabel = _ref.hideLabel,
      isReadOnly = _ref.isReadOnly,
      label = _ref.label,
      input = _ref.input,
      isDisabled = _ref.isDisabled,
      isRequired = _ref.isRequired,
      FormGroupProps = _ref.FormGroupProps,
      Component = _ref.Component,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["meta", "validateOnMount", "helperText", "description", "hideLabel", "isReadOnly", "label", "input", "isDisabled", "isRequired", "FormGroupProps", "Component"]);

  var _useContext = (0, _react.useContext)(_blueprintContext["default"]),
      required = _useContext.required;

  var error = meta.error,
      touched = meta.touched,
      warning = meta.warning,
      submitError = meta.submitError;
  var showError = (validateOnMount || touched) && (error || submitError);
  var showWarning = (validateOnMount || touched) && warning;
  var text = showError || showWarning || helperText || description;
  var intent = showError && {
    intent: _intent.Intent.DANGER
  } || showWarning && {
    intent: _intent.Intent.WARNING
  };
  var labelInfo = !hideLabel && isRequired && {
    labelInfo: required
  };
  return /*#__PURE__*/_react["default"].createElement(_formGroup.FormGroup, (0, _extends2["default"])({
    helperText: text,
    label: !hideLabel && label,
    labelFor: input.name
  }, labelInfo, FormGroupProps, intent), /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({
    providerRequired: required,
    disabled: isDisabled || isReadOnly
  }, rest, {
    label: label,
    isRequired: isRequired,
    input: input
  }, intent)));
};

exports.FormGroupInternal = FormGroupInternal;
FormGroupInternal.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  Component: _propTypes["default"].any,
  helperText: _propTypes["default"].node,
  label: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  description: _propTypes["default"].node,
  FormGroupProps: _propTypes["default"].object,
  hideLabel: _propTypes["default"].bool,
  meta: _propTypes["default"].object,
  input: _propTypes["default"].object
};

var FormGroupWrapper = function FormGroupWrapper(props) {
  var rest = (0, _useFieldApi["default"])(props);
  return /*#__PURE__*/_react["default"].createElement(FormGroupInternal, rest);
};

var _default = FormGroupWrapper;
exports["default"] = _default;