"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _wizard = _interopRequireDefault(require("@data-driven-forms/common/wizard/wizard"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var _wizardContext = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/wizard-context"));

var _stepButtons = _interopRequireDefault(require("./step-buttons"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var WizardInternal = function WizardInternal(_ref) {
  var WizardProps = _ref.WizardProps,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["WizardProps"]);

  var _useContext = (0, _react.useContext)(_wizardContext["default"]),
      formOptions = _useContext.formOptions,
      currentStep = _useContext.currentStep,
      onKeyDown = _useContext.onKeyDown,
      rest = (0, _objectWithoutProperties2["default"])(_useContext, ["formOptions", "currentStep", "onKeyDown"]);

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    onKeyDown: onKeyDown
  }, WizardProps), currentStep.fields.map(function (item) {
    return formOptions.renderForm([item], formOptions);
  }), /*#__PURE__*/_react["default"].createElement(_formSpy["default"], {
    subscription: {
      valid: true,
      submitting: true,
      validating: true
    }
  }, function (_ref2) {
    var valid = _ref2.valid,
        submitting = _ref2.submitting,
        validating = _ref2.validating;
    return /*#__PURE__*/_react["default"].createElement(_stepButtons["default"], (0, _extends2["default"])({
      isNextDisabled: !valid || submitting || validating
    }, props, rest, {
      currentStep: currentStep,
      formOptions: formOptions
    }));
  }));
};

WizardInternal.propTypes = {
  WizardProps: _propTypes["default"].object
};
var defaultLabels = {
  submit: 'Submit',
  cancel: 'Cancel',
  back: 'Back',
  next: 'Next'
};

var Wizard = function Wizard(_ref3) {
  var buttonLabels = _ref3.buttonLabels,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["buttonLabels"]);
  return /*#__PURE__*/_react["default"].createElement(_wizard["default"], (0, _extends2["default"])({
    Wizard: WizardInternal
  }, props, {
    buttonLabels: _objectSpread(_objectSpread({}, defaultLabels), buttonLabels)
  }));
};

Wizard.propTypes = {
  buttonLabels: _propTypes["default"].object
};
var _default = Wizard;
exports["default"] = _default;